/*
	GP3200 EMU header
	cording by taka
	version : 2.0
*/

#include <stdio.h>
#include <string.h>

#ifndef __GP3200_H__
#define __GP3200_H__

#ifndef UINT8
typedef unsigned char UINT8;
#endif
#ifndef UINT16
typedef unsigned short UINT16;
#endif
#ifndef UINT32
typedef unsigned int UINT32;
#endif
#ifndef UINT
typedef unsigned int UINT;
#endif
#ifndef INT8
typedef signed char INT8;
#endif
#ifndef INT16
typedef signed short INT16;
#endif
#ifndef INT32
typedef signed int INT32;
#endif

#define		ARGS_IR		(0x00)
#define		ARGS_MR		(0x01)
#define		ARGS_ME		(0x02)
#define		ARGS_E		(0x03)
#define		ARGS_FR		(0x04)
#define		ARGS_FE		(0x05)
#define		ARGS_SR		(0x06)

typedef UINT32 gp3200_float;

typedef struct {
	/* register */
	UINT32 r_regs[32]; /* R0 - R31 */
	UINT32 r_segs[8]; /* S0 - S7 */ /* CS = S0 , DS = S1 */
	gp3200_float f_regs[32]; /* F0 - F31 */
	UINT32 r_pc;
	UINT32 r_sp;
	
	/* use emulation */
	UINT16 r_cmp;
	UINT8 r_if;
	UINT32 r_ret;
	UINT32 r_retcs;
	
	/* i/o & memory */
	UINT8 *r_memory;
	UINT32 *r_port;

	/* callback */
	void (*on_int)(void *cpu,int intno,UINT8 *r_memory);
} gp3200_cpu;

/* float32.c */
gp3200_float gp3200_f32_float2f32(double val);
gp3200_float gp3200_f32_int2float(UINT32 val);
gp3200_float gp3200_f32_fadd(gp3200_float val1, gp3200_float val2);
gp3200_float gp3200_f32_fsub(gp3200_float val1, gp3200_float val2);
gp3200_float gp3200_f32_fmul(gp3200_float val1, gp3200_float val2);
gp3200_float gp3200_f32_fdiv(gp3200_float val1, gp3200_float val2);
double gp3200_f32_getfloat(gp3200_float float32);

/* gp3200.c */
void gp3200_init(gp3200_cpu *cpu, UINT8 *memory);
void gp3200_step(gp3200_cpu *cpu);

#endif
